/* machtad.c machine-style tad calculator SLOW! */

int apply(int, int);

void send(int, int);
int cvtFromArray(void);
void cvtToArray(int);

int ls[13];		/* state 1 or 0 of 13 lamps */
int wiring[13][4][2] = {
	{{5, 3}, {-1, -1}, {-1, -1}, {3, 1}},
	{{3, 4}, {0, 3}, {-1, -1}, {4, 2}},
	{{4, 7}, {1, 4}, {-1, -1}, {-1, -1}},

	{{5, 6}, {0, 5}, {1, 0}, {6, 1}},
	{{6, 7}, {1, 6}, {2, 1}, {7, 2}},

	{{10, 8}, {-1, -1}, {3, 0}, {8, 3}},
	{{8, 9}, {3, 8}, {4, 3}, {9, 4}},
	{{9, 12}, {4, 9}, {2, 4}, {-1, -1}},


	{{10, 11}, {5, 10}, {6, 5}, {11, 6}},
	{{11, 12}, {6, 11}, {7, 6}, {12, 7}},
	
	{{-1, -1}, {-1, -1}, {8, 5}, {11, 8}},
	{{-1, -1}, {8, 10}, {9, 8}, {12, 9}},
	{{-1, -1}, {9, 11}, {7, 9}, {-1, -1}},
};

int buttonmap[12][2] = {		/* direction, lamp of buttin number */
	{0, 0},
	{0, 1},
	{0, 2},

	{1, 2},
	{1, 7},
	{1, 12},

	{2, 12},
	{2, 11},
	{2, 10},

	{3, 10},
	{3, 5},
	{3, 0},
};

int apply(int state, int button)
{
	cvtToArray(state);
	send(buttonmap[button][0], buttonmap[button][1]);
	return (cvtFromArray());
}
	
void send(int direction, int lampNumber)
{
	int i;

	if (lampNumber < 0)
		return;
	
	i = ls[lampNumber];
	ls[lampNumber] = 1 - ls[lampNumber];	/* toggle */
	
	send(direction, wiring[lampNumber][direction][i]);
}

int cvtFromArray(void)
{
	int i;
	int k = 1;
	int s = 0;
	
	for (i = 0; i < 13; i++, k <<= 1)
		if (ls[i]) s += k;

	return (s);
}

void cvtToArray(int numb)
{
	int i;
	int k = 1;
	int s = 0;
	
	for (i = 0; i < 13; i++, k <<= 1)
		if (numb & k) ls[i] = 1;
		else ls[i] = 0;
}
